=== debian/changelog ===
lapackpp (2023.08.25-2) unstable; urgency=medium

  * debian/patches/reproducible-build.patch: New patch, making the build
    reproducible, by Chris Lamb (Closes: #1053205).

 -- Michael Banck <mbanck@debian.org>  Sat, 30 Sep 2023 13:32:46 +0200

lapackpp (2023.08.25-1) unstable; urgency=medium

  * Initial upload.

 -- Michael Banck <mbanck@debian.org>  Tue, 12 Sep 2023 15:07:00 +0530
