## lapackpp 2023.11.05

=== CMakeLists.txt ===
--- 
+++ 
@@ -15,7 +15,7 @@
 
 project(
     lapackpp
-    VERSION 2023.08.25
+    VERSION 2023.11.05
     LANGUAGES CXX
 )
 
@@ -523,17 +523,15 @@
     src/cuda/cuda_geqrf.cc
     src/cuda/cuda_getrf.cc
     src/cuda/cuda_potrf.cc
+    src/cuda/cuda_heevd.cc
 
     src/rocm/rocm_geqrf.cc
     src/rocm/rocm_getrf.cc
     src/rocm/rocm_potrf.cc
+    src/rocm/rocm_heevd.cc
 
     src/onemkl/onemkl_geqrf.cc
     src/onemkl/onemkl_getrf.cc
     src/onemkl/onemkl_potrf.cc
-
-    src/stub/stub_geqrf.cc
-    src/stub/stub_getrf.cc
-    src/stub/stub_potrf.cc
-)
-
+    src/onemkl/onemkl_heevd.cc
+
