=== test/CMakeLists.txt ===
--- 
+++ 
@@ -22,7 +22,7 @@
         message( "   Found TestSweeper library: ${testsweeper_DIR}" )
     else()
         set( url "https://github.com/icl-utk-edu/testsweeper" )
-        set( tag "v2023.08.25" )
+        set( tag "v2023.11.05" )
         message( "" )
         message( "---------- TestSweeper" )
         message( STATUS "Fetching TestSweeper ${tag} from ${url}" )
@@ -96,6 +96,7 @@
     test_hecon.cc
     test_heev.cc
     test_heevd.cc
+    test_heevd_device.cc
     test_heevr.cc
     test_heevx.cc
     test_hegst.cc
