=== debian/changelog ===
lapackpp (2023.11.05-1) unstable; urgency=medium

  * New upstream release.

 -- Michael Banck <mbanck@debian.org>  Fri, 29 Dec 2023 19:47:36 +0100
