## lapackpp 2024.05.31

=== CMakeLists.txt ===
--- 
+++ 
@@ -15,9 +15,15 @@
 
 project(
     lapackpp
-    VERSION 2023.11.05
+    VERSION 2024.05.31
     LANGUAGES CXX
 )
+
+# See notes in GNUmakefile about using abi-compliance-checker.
+# soversion is major ABI version.
+set( abi_version 1.0.0 )
+string( REPLACE "." ";" abi_list "${abi_version}" )
+list( GET abi_list 0 soversion )
 
 include( CheckCXXCompilerFlag )
 
@@ -113,6 +119,8 @@
 gpu_backend            = ${gpu_backend}
 lapackpp_is_project    = ${lapackpp_is_project}
 lapackpp_              = ${lapackpp_}
+abi_version            = ${abi_version}
+soversion              = ${soversion}
 " )
 
 #-------------------------------------------------------------------------------
@@ -517,21 +525,9 @@
     src/unmtr.cc
     src/upgtr.cc
     src/upmtr.cc
+    src/util.cc
     src/version.cc
 
     src/cuda/cuda_common.cc
     src/cuda/cuda_geqrf.cc
     src/cuda/cuda_getrf.cc
-    src/cuda/cuda_potrf.cc
-    src/cuda/cuda_heevd.cc
-
-    src/rocm/rocm_geqrf.cc
-    src/rocm/rocm_getrf.cc
-    src/rocm/rocm_potrf.cc
-    src/rocm/rocm_heevd.cc
-
-    src/onemkl/onemkl_geqrf.cc
-    src/onemkl/onemkl_getrf.cc
-    src/onemkl/onemkl_potrf.cc
-    src/onemkl/onemkl_heevd.cc
-
