=== test/CMakeLists.txt ===
--- 
+++ 
@@ -22,7 +22,7 @@
         message( "   Found TestSweeper library: ${testsweeper_DIR}" )
     else()
         set( url "https://github.com/icl-utk-edu/testsweeper" )
-        set( tag "v2023.11.05" )
+        set( tag "v2024.05.31" )
         message( "" )
         message( "---------- TestSweeper" )
         message( STATUS "Fetching TestSweeper ${tag} from ${url}" )
