=== debian/changelog ===
lapackpp (2024.05.31-1) unstable; urgency=medium

  * New upstream release.

 -- Michael Banck <mbanck@debian.org>  Sat, 21 Sep 2024 14:17:32 +0200
