## lapackpp 2024.10.26

=== CMakeLists.txt ===
--- 
+++ 
@@ -15,7 +15,7 @@
 
 project(
     lapackpp
-    VERSION 2024.05.31
+    VERSION 2024.10.26
     LANGUAGES CXX
 )
 
@@ -291,7 +291,9 @@
     src/lacgv.cc
     src/lacp2.cc
     src/lacpy.cc
+    src/lae2.cc
     src/laed4.cc
+    src/laev2.cc
     src/lag2c.cc
     src/lag2d.cc
     src/lag2s.cc
@@ -299,7 +301,6 @@
     src/lagge.cc
     src/laghe.cc
     src/lagsy.cc
-    src/lamch.cc
     src/langb.cc
     src/lange.cc
     src/langt.cc
@@ -333,6 +334,7 @@
     src/lartgs.cc
     src/lascl.cc
     src/laset.cc
+    src/lasr.cc
     src/lassq.cc
     src/laswp.cc
     src/lauum.cc
@@ -530,4 +532,3 @@
 
     src/cuda/cuda_common.cc
     src/cuda/cuda_geqrf.cc
-    src/cuda/cuda_getrf.cc
