=== examples/Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# Copyright (c) 2017-2022, University of Tennessee. All rights reserved.
+# Copyright (c) 2017-2023, University of Tennessee. All rights reserved.
 # SPDX-License-Identifier: BSD-3-Clause
 # This program is free software: you can redistribute it and/or modify it under
 # the terms of the BSD 3-Clause license. See the accompanying LICENSE file.
