=== test/CMakeLists.txt ===
--- 
+++ 
@@ -124,7 +124,9 @@
     test_hptri.cc
     test_hptrs.cc
     test_lacpy.cc
+    test_lae2.cc
     test_laed4.cc
+    test_laev2.cc
     test_langb.cc
     test_lange.cc
     test_langt.cc
@@ -148,6 +150,7 @@
     test_larfx.cc
     test_larfy.cc
     test_laset.cc
+    test_lasr.cc
     test_laswp.cc
     test_pbcon.cc
     test_pbequ.cc
