=== debian/changelog ===
lapackpp (2024.10.26-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches/reproducible-build.patch: Removed, applied upstream. 

 -- Michael Banck <mbanck@debian.org>  Mon, 10 Mar 2025 00:54:03 +0100
